#! /usr/bin/env python2.5

from merescocore.framework import be
from merescocore.components import readConfig
from merescocore.components.http import ObservableHttpServer
from bzv.oaiserver import main
from weightless import Reactor
from sys import stderr, stdout, argv

args = argv[1:]
if len(args) == 1:
	configFile = args[0]
	config = readConfig(configFile)

reactor = Reactor()
oaiPortNumber=int(config['oaiPortNumber'])
observableHttpServer = ObservableHttpServer(reactor, oaiPortNumber)
observableHttpServer.startServer()

processorHelix, serverHelix = main(reactor,
	observableHttpServer, 
	inboxDirectory=config['inboxDirectory'],
	doneDirectory=config['doneDirectory'],
	databasePath=config['databasePath'],
	oaiAdminEmail=config['oaiAdminEmail'],
	oaiRepositoryName=config['oaiRepositoryName'],
        stdoutStream=stdout,
        stderrStream=stderr)

processor = be(processorHelix)
server = be(serverHelix)
processor.once.observer_init()
server.once.observer_init()

print "Ready to rumble at port %s." % int(config['oaiPortNumber'])
stdout.flush()
reactor.loop()
