// $Id: bzv.js 2083 2009-09-08 12:30:09Z anton $
// $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-7.1.0/html/static/bzv.js $
//
// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
if( typeof XMLHttpRequest == "undefined" ) XMLHttpRequest = function() {
  try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
  try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
  throw new Error( "This browser does not support XMLHttpRequest." )
};

/*
More information from http://www.w3.org/TR/XMLHttpRequest/
*/

//FIXME: config. To be synchronised with etc/availability.cfg
// Use this notation to comfort IE
var translateHash = new Array ();
translateHash['linkMethod']  = 'Fulltext via provider';
translateHash['onLoan']      = 'On loan. Reserve';
translateHash['ILL']         = 'Document delivery';
translateHash['inLibrary']   = 'In the Library';
translateHash['inDepot']     = 'Request item from depot';
translateHash['moreInfo']    = 'Get more information';
translateHash['showDetails'] = 'Show details';
translateHash['hideDetails'] = 'Hide details';

var depotCollectionList = ['CBC', 'CBM', 'CIF',
                 'ECO',
                 'KHS', 'KOD', 'KTFK HS', 'KTFK INC',
                 'SOC',
                 'TESTOTHEEK', 'TF HS', 'TF INC', 'TF PRE', 'TFK E', 'TRE'];

var depotExceptionList =  ['CIF SB', 'SOC SB', 'ECO SB'];

function inDepot(callNumber){
    var inDepot = false
    for (var i in depotCollectionList){
        if (callNumber.indexOf(depotCollectionList[i]) == 0){
            inDepot = true;
            for(var j in depotExceptionList){
                if (callNumber.indexOf(depotExceptionList[j]) == 0){
                    inDepot = false;
                    break;
                }
            }
            if (inDepot) return true;
        }
    }
    return false;
}

var lex = new Array();
// based on the translations of iPort
// note that this list contains improvements
lex['ABI']= 'ABI/INFORM';
// the name of the provider ends with a 's'
lex['AnnualReviews']='Annual Reviews';
lex['springerlink']='SpringerLink';
lex['KLUWER']='Kluwer';
lex['Karger']='Karger';
lex['MLCV']='Multilingual Matters and Channel View Publications';
lex['OUP']='Oxford University Press';
lex['ovid']='Ovid';
// first letter -> capitial
lex['LawrenceErlbaum']='Lawrence Erlbaum';
lex['CUP']='Cambridge University Press';
lex['JSTOR']='JSTOR';
lex['SD']='Science Direct';
lex['SIAM']='SIAM Journals';
lex['HAWORTH']='Haworth Press';
lex['EMERALD']='Emerald';
lex['CP']='Chicago Press';
lex['TF']='Informaworld';
lex['aaapubs']='American Accounting Association';
lex['AMAA']   ='American Marketing Association';
lex['AMA']    ='American Medical Association';
lex['AAAS']   ='American Association for the Advancement of Science';
lex['AARM']   ='American Association Mental Retardation';
lex['APP']    ='American Psychiatric Publication Group';
lex['ASA']    ='American Statistical Association';
lex['ACM']    ='Association for Computing Machinery';
lex['LWW']='Lippincot Williams and Wilkins';
lex['IPO']='Informs Pubs Online';
lex['WdGr']='Walter de Gruyter';
lex['Metapress']='Metapress';
lex['IBFD']='International Bureau of Fiscal Documentation';
lex['WSP']='World Scientific Publishers';
lex['Extenza']='Atypon Link';
lex['Palgrave']='Palgrave MacMillan';
lex['DOAJ']='Directory of Open Access Journals'
lex['OECD']='sourceOECD';
lex['EUP']='Edinburgh University Press';
lex['FirstSearch']='OCLC-First Search';
lex['KLI']='Kluwer Law International';
lex['NJB']='Nederlands Juristenblad';
lex['NOW']='Now'
lex['DUP']='Duke University Press';
lex['NASW']='National Institute of Social Workers';
lex['VenR']='Vandenhoeck &amp; Ruprecht'
lex['WESTLAW']='Westlaw';
lex['Mit']='MIT Press Journals'
lex['Hart']='Hart Journals';
lex['Clark']='Clark University';
lex['HKP']='Human Kinetics Publishers';
lex['juris']='Jurisquare';
lex['Login-Hint']='Journal';
lex['Highwire']='Highwire Press';
lex['NBLC']='Biblion';
lex['HC']='History Cooperative';
lex['catchword']     ='IngentaConnect';
lex['INGENTA']       ='IngentaConnect';
lex['IngentaConnect']='IngentaConnect';
lex['IOS']='IOS Press';
lex['Liebert']='Liebert Online';
lex['NCTE']='National Council of Teachers of English';
lex['NDFR']='Nederlandse Documentatie Fiscaal Recht';
lex['NEJM']='New England Journal of Medicine';
lex['PPP']='Physicians Postgraduate Press';
lex['RCP']='Royal College of Psychiatrics';
lex['WPNR']='Weekblad voor Privaatrecht, Notariaat en Registratie';
// added 'Interscience'
lex['Blackwell']='Wiley InterScience';
lex['wiley']    ='Wiley InterScience';
lex['WL']='World Leisure';
lex['WorldSP']='World Scientific Publishers';
lex['ILL']='Request document';

function initFocus(){
    var el = document.getElementById('searchQuery');
    if (typeof(el) != "undefined")
	if (el) el.focus();
}

function extractData(record) {
    var data = new Object();
    var fields = record.childNodes;
    var numFields = fields.length;
    for(var j = 0; j < numFields; j++) {
        var field = fields[j];
        if(!field.tagName) continue;
        if(field.childNodes && field.childNodes[0])
            data[field.tagName] = field.childNodes[0].nodeValue;
    }
    return data;
}

function createLinkDiv(url, displayText, imageBoolean){
    if (lex[displayText]) displayText=lex[displayText];
    var divNode = document.createElement("div");
    if (imageBoolean){
	var imageNode = document.createElement("img");
	imageNode.setAttribute("src", "/files/edoc.gif");
	imageNode.setAttribute("alt", "*");
	divNode.appendChild(imageNode);
    }
    var linkNode = document.createElement("a");
    linkNode.setAttribute("href", url);
    linkNode.setAttribute("target", "_blank");
    linkNode.appendChild(document.createTextNode(displayText));
    divNode.appendChild(linkNode);
    return divNode;
}

function createDepotRequest(db, location, displayText) {
    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
        "&searchField=sgn&query=" + location;
    return createLinkDiv(url, displayText, false);
}

function translate(key ) {
    var value =  translateHash[key];
    if (!value) value = 'UNDEFINED';
    return value;
}

function processLocatorInfo(o, genre, nodeHash){
    var rootNode = o.responseXML.documentElement;
    var records = rootNode.childNodes;
    var numRecords = records.length;
    for(var i = 0; i < numRecords; i++) {
        var record = records[i];
        if(!record.tagName || record.tagName != 'record') continue;
        processRecordWithLocatorInfo(record, genre, nodeHash);
    }
}

function processRecordWithLocatorInfo(record, genre, nodeHash){
    var locInfo = extractData(record);
    var url = locInfo.generatedUrl;

    if (url && url.indexOf('://') != -1){
        var image = true;
        var group = "linkMethod";
        if (locInfo.linkMethod == 'ILL'){
            image = false;
            group = "ILL";
       }
        nodeHash[group].push(createLinkDiv(url, locInfo.linkMethod, image));
    }
    else {
        callNumber = locInfo.callNumber;
        if (genre == "article"){
            if (callNumber.indexOf('T ') == 0 || callNumber.indexOf('TF ') == 0){
                // this test is to filter non-journals; however there are call number for books that start with "TF "
                // this problem will be solved when full-journal-title searching is implemented
                var col = locInfo.collection;
                // FIXME: config
                if (col == "ECO" ||
                    col == "JUR" || col == "SOC" || col == "LET" || col == "CIF" || col == "TFL" || col == "BRA" || col == "GES" || col == "DISC")
                    {
                        nodeHash['inLibrary'].push(document.createTextNode(callNumber + " (" + col + ")"));
                    }
                else if (col) {
                    // test met:
                    // ?recordId=RePEc-kap-pubcho:oai:RePEc:kap:pubcho:v:110:y:2002:i:3-4:p:327-50
                    var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=tuts&searchField=sgn&query=" + callNumber;
                    nodeHash['inDepot'].push(createLinkDiv( url, callNumber, false));
                }
            }
        }
        else {
            if (callNumber) {
                processRecordWithCirculationInfo(record, genre, nodeHash);
            }
        }
    }
}

function processRecordWithCirculationInfo(record, genre, nodeHash){
    var locInfo = extractData(record);
    var db = "tucat";
    if (genre == "journal") db = "tuts";
    var status = locInfo.status;
    var callNumber = locInfo.callNumber;

    // copy of inzage
    if (status == 'i' || status == 'f'){
        displayText = callNumber + " (not for loan)"
        if (inDepot(callNumber)) nodeHash['inDepot'].push(createDepotRequest(db, callNumber, displayText));
        else
            nodeHash['inLibrary'].push(document.createTextNode(displayText));
        return;
    }

    var availStatus = record.getElementsByTagName("dlf:availabilitystatus");
    if (availStatus.length > 0){
        availability = availStatus[0].childNodes[0].nodeValue;
        if (availability == 'available') {
            if (inDepot(callNumber))
                nodeHash['inDepot'].push(createDepotRequest(db, callNumber, callNumber));
            else
                nodeHash['inLibrary'].push(document.createTextNode(callNumber));
        }
        else if (availability == 'not available'){
           var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
               "&searchField=sgn&query=" + callNumber;
           nodeHash['onLoan'].push(createLinkDiv(url, callNumber, false));
        }
        else if (availability == 'unknown'){
           var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
               "&searchField=sgn&query=" + callNumber;
           nodeHash['moreInfo'].push(createLinkDiv(url, callNumber, false));
       }
    }
    else if (callNumber){
        var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=" + db +
            "&searchField=sgn&query=" + callNumber;
        nodeHash['moreInfo'].push(createLinkDiv(url, callNumber, false));
    }
    else if (locInfo.linkMethod = 'ILL')
        nodeHash['ILL'].push(createLinkDiv(locInfo.generatedUrl, locInfo.linkMethod, false));
}

function processCirculationInfo(o, genre, nodeHash){
   var rootNode = o.responseXML.documentElement;
   var records = rootNode.childNodes;
   var numRecords = records.length;
   for(var i = 0; i < numRecords; i++) {
       var record = records[i];
       if (record.tagName && record.tagName == 'record')
           processRecordWithCirculationInfo(record, genre, nodeHash);
   }
}

function presentAvailability(node, o, openurl, location) {
    var query = openurl.split("?")[1];
    var pairs = query.split("&");
    var genre = ""
    for (var i=0; i < pairs.length; i++) {
        var pair = pairs[i].split("=");
        if (pair[0] == "genre") {
            genre = pair[1];
        }
    }

    var lijst = new Array ('linkMethod','inLibrary','inDepot','moreInfo','ILL');
    var nodeHash = new Array ();
    for ( var el in lijst ){
	nodeHash[lijst[el]] =  new Array ();
    }

    if (!location){
        processLocatorInfo(o, genre, nodeHash);
    }
    else {
        processCirculationInfo(o, genre, nodeHash);
    }

    for ( var el in lijst ){
        var group = lijst[el];
        if ( nodeHash[group].length > 0 ){
            var titleNode = document.createElement("li");
            YAHOO.util.Dom.addClass(titleNode, "title");
            titleNode.appendChild(document.createTextNode(translate(group)));
            node.appendChild(titleNode);

            for ( var link in nodeHash[group] ){
                var liNode = document.createElement("li");
                liNode.appendChild( nodeHash[group][link] );
                node.appendChild(liNode);
	    }
        }
    }
}

function openurl(nodeid, openurl){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
        var location = ""
	presentAvailability(node, o, openurl, location);
    }

    function failureHandler(o)
    {
	/*
	if (console)
	    console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );
	*/

	node.appendChild(document.createTextNode("Locator unavailable"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', openurl, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
}

// what is the use of this function?
function getElementsByClass(node,searchClass,tag) {
    var classElements = new Array();
    var els = node.getElementsByTagName(tag); // use "*" for all elements
    var elsLen = els.length;
    var i, j;
    for (i = 0, j = 0; i < elsLen; i++) {
         if (els[i].className == searchClass) {
             classElements[j] = els[i];
             j++;
         }
    }
    return classElements;
}

function availability(nodeid, location, inDepot, genre, openurl){
    var node = document.getElementById(nodeid);
    // console.log("nodeid:'" + nodeid + "'");

    function successHandler(o) {
        presentAvailability(node, o, openurl, location);
    }

    function failureHandler(o)
    {
	/*
	if (console)
	    console.log('Meresco:availability XMLHttpRequest statusText: ' + o.statusText );
	*/
	node.appendChild(document.createTextNode("No availability information"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', openurl, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
}

// searchForm stuff
function relocateKeepDrilldown(  drilldown){
    var searchQuery = document.getElementById('searchQuery');
    var newLocation = "?query=" + escape(searchQuery.value);

    if (drilldown){
	newLocation += drilldown;
    }
    top.location= newLocation;
    return false;
}

function relocateKeepQuery( obj ){
    var searchQuery = getElementById('searchQuery');
    var newQuery = "?query=" + escape(searchQuery.value);
    var newLocation = newQuery + '&' + obj.value ;
    top.location= newLocation;
}

function relocateKeepQueryHref( query ){
    var searchQuery = document.getElementById('searchQuery');
    var newQuery = "?query=" + escape(searchQuery.value);
    var newLocation = newQuery + '&' + query
    top.location= newLocation;
    return false;
}

function clearSearch(){
    var l=top.location;
    var port=l.port;
    if (l.port)
	port=":"+port;

    top.location=l.protocol + "//" + l.hostname + l.pathname + port;
}


// YAHOO stuff
modules  = new Array();

function clone(node) {
    var tagName = node.tagName;
    var nodeValue = node.nodeValue;

    if(tagName) {
	var cln = document.createElement(tagName);

	var att = node.attributes;
	for(var i = 0; i < att.length; i++)
	    cln.setAttribute(att[i].name, att[i].value);

	var chi = node.childNodes;
	for(var i = 0; i < chi.length; i++)
	    cln.appendChild(clone(chi[i]));

	return cln;
    } else if(nodeValue) {
	return document.createTextNode(nodeValue);
    }
}


function extractRecord(xmlDoc) {
    var rootNode = xmlDoc.documentElement;

    if(rootNode.nodeName=='parsererror') {
	if (console)
	    console.error( rootNode.firstChild.nodeValue);
    	//debugger;
    }

    var data = new Array();
    var fields = rootNode.childNodes;

    for(var i = 0; i < fields.length; i++ ) {
        var field = fields[i];

        if(!field.tagName || field.tagName != 'field')
            continue;

	var datum = new Object();

        var fieldElements = field.childNodes;
        for(var j = 0; j < fieldElements.length; j++ ) {
            var fieldElement = fieldElements[j];
	    var tagName = fieldElement.tagName;

           if(!tagName)
                continue;

            if(tagName == 'label')
		datum.label = fieldElement.childNodes[0].nodeValue;
	    else
		datum.content = fieldElement;
        }
	data.push(datum);
    }
    return data;
}

function presentData(dataArray, widget, index) {
    var tableNode = document.getElementById('table'+index);
    // Cleanup previous results
    while (tableNode.firstChild) {
	tableNode.removeChild(tableNode.firstChild);
    }

    // DO NOT use e.setAttribute("class", "classname");
    // because IE will ignore the call comletely.
    // In stead use:
    // YAHOO.util.Dom.addClass(tableNode, "recordElementTable");

    // For IE 'tbody' is required
    var tBodyNode  = document.createElement('tbody');
    YAHOO.util.Dom.addClass(tBodyNode, "recordElementTableBody");

    for(var i = 0; i < dataArray.length ; i++) {
        var field =              dataArray[i];
        var rowNode =            document.createElement('tr');
        var thLabelNode =        document.createElement('th');
        var tdContentNode =      document.createElement('td');

	thLabelNode.appendChild(document.createTextNode(field.label));
	rowNode.appendChild(thLabelNode);

	var childNodes = field.content.childNodes;
	for(var j = 0; j < childNodes.length; j++) {
	    if(childNodes[j]) {
		var chi = clone(childNodes[j]);
		tdContentNode.appendChild(chi);
	    }
	}
	rowNode.appendChild(tdContentNode);
	tBodyNode.appendChild(rowNode);
	tableNode.appendChild(tBodyNode);

	// IE Cannot handle the next line, even if it is made conditional.
	//if (console)
	//    console.log ( "classname is: " + YAHOO.util.Dom.get('recordElementLabel-'+index).className);

    }
}

function getContent(widget,recordId,index)
{
    function successHandler(o) {
        var data = extractRecord(o.responseXML);
        presentData(data, widget, index);
    }

    function failureHandler(o) {
        if (console)
            console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );

        var widgetNode=document.getElementById("content"+index);
	// Fixme:  moet dit addClass worden?
        widgetNode.setAttribute("class","recordElementContentError");
        widget.setBody("Record information could not be retrieved: "+o.statusText);
    }

    var request = YAHOO.util.Connect.asyncRequest('GET',"/record?recordId="+recordId, {
            success:successHandler,
            failure:failureHandler,
            timeout: 15000
        });
}

function generateMoreinfoToggler(index, buttonPreName, recordId){
    var more = translate("showDetails");
    var less = translate("hideDetails");

    YAHOO.util.Event.onDOMReady(function () {
            modules[index]=new Array();
            modules[index].button =
                new YAHOO.widget.Button({ type: "checkbox",
					  label: more,
					  id: "checkbutton"+index, name: "checkboxfield"+index,
					  value: "1",
					  container: "moduleContainer"+index, checked: false });

            modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: false });
            modules[index].widget.render();

            function onCheckedChange(e) {
                if (e.newValue) {
                    modules[index].button.set('label',less);
                    getContent(modules[index].widget,recordId,index );
                    modules[index].widget.show();
                } else {
                    modules[index].widget.hide();
                    modules[index].button.set('label',more);
                }
                modules[index].widget.render();
            }
            modules[index].button.addListener("checkedChange", onCheckedChange);

	});
}

// YAHOO stuff end
