from merescocore.framework import Observable

class ComposeDaiFromMods(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3', 'dai': 'info:eu-repo/dai'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        identifiers = lxmlNode.xpath('//mods:extension/dai:daiList/dai:identifier', self._namespaceMap)
        for identifier in identifiers:
            authority = identifier.xpath('@authority', self._namespaceMap)
            text = identifier.xpath('text()', self._namespaceMap)
            dai = ''
            if len(authority) == 1:
                dai = str(authority[0])
                if not dai.endswith('/'):
                    dai += '/'
            if len(text) == 1:
                dai += str(text[0])
            if dai: yield self.all.addField(name=self._fieldName, value=dai)
