from merescocore.framework import Observable

class ComposeJELFromMods(Observable):
    def __init__(self, fieldName):
        Observable.__init__(self)
        self._namespaceMap = {'mods':'http://www.loc.gov/mods/v3'}
        self._fieldName = fieldName

    def add(self, id, partName, lxmlNode):
        classifications = lxmlNode.xpath('//mods:mods/mods:classification', self._namespaceMap)
        for classification in classifications:
            authority = classification.xpath('@authority', self._namespaceMap)
            text = classification.xpath('text()', self._namespaceMap)
            if len(authority) == 1:
                if str(authority[0]) == 'info:eu-repo/authority/jel':
                    if len(text) == 1:
                        yield self.all.addField(name=self._fieldName, value=str(text[0]))
