
def readToc(next):
    readJournalIssue = lambda parentData, next: readItem('_t2', ['_t3'], readEditorialItem, parentData, next)
    readJournalTitle = lambda parentData, next: readItem('_t1', ['_t2'], readJournalIssue, parentData, next)
    readDataSet = lambda parentData, next: readItem('_t0', ['_t1'], readJournalTitle, parentData, next)
    code = yield nextCode()
    if code == '_t0':
        yield readDataSet({}, next)

def readEditorialItem(parentData, next):
    myItemCode = '_t3'
    containedItemCodes =  ['_t1', '_t2', '_t3']
    
    mydata = {'parent':parentData}
    identifier = yield nextValue()
    dictionaryAdd(mydata, myItemCode, identifier)
    code = yield nextCode()
    try:
        while code not in containedItemCodes:
            value = yield nextValue()
            dictionaryAdd(mydata, code, value)
            code = yield nextCode()
    finally:
        next.send(mydata)
        raise StopIteration(code)

def readItem(myItemCode, containedItemCodes, nextItemGenerator, parentData, next):
    mydata = {'parent': parentData}
    identifier = yield nextValue()
    dictionaryAdd(mydata, myItemCode, identifier)
    code = yield nextCode()
    while code not in containedItemCodes:
        value = yield nextValue()
        dictionaryAdd(mydata, code, value)
        code = yield nextCode()
    
    nextItemCode = yield nextItemGenerator(mydata, next)
    while nextItemCode in containedItemCodes:
        nextItemCode = yield nextItemGenerator(mydata, next)
    raise StopIteration(nextItemCode)

def dictionaryAdd(dict, key, value):
    if key not in dict:
        dict[key] = []
    dict[key].append(value)

def nextCode():
    line = yield
    code, value = line[:3], line[4:]
    raise StopIteration(code, value)

def nextValue():
    value = (yield).rstrip()
    try:
        nextline = yield
        while nextline[:3] == '   ':
            value += nextline[3:].rstrip()
            nextline = yield
    except StopIteration:
        raise StopIteration(value)
    else:
        raise StopIteration(value, nextline)

