# $Id: infra.py 2058 2009-09-04 12:07:17Z anton $
# $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-7.1.0/src/infra.py $
import os
import logging
import logging.config
import pprint
import sys
from traceback import format_tb

#
# Create a hive mind:
# http://www.eecho.info/Echo/python/singleton/
#

class Borg(object):
    _state = {}
    def __new__(cls, *args, **kw):
        ob = super(Borg, cls).__new__(cls, *args, **kw)
        ob.__dict__ = cls._state
        return ob

class Infra (Borg):
    def __init__(self, startupMessage = '', loggingConfigfile = None ):
        self.status = False

        if (loggingConfigfile):
            self.loggingConfigfile = loggingConfigfile

        self._startLogging(startupMessage)
        self._prettyPrint()

    def _startLogging(self,startupMessage):
        # import logging
        self.logging=logging
        try:
            logging.config.fileConfig(self.loggingConfigfile)
            self.status=True

        except Exception, e:
            sys.stderr.write ('ERROR: Could not parse loggingConfigfile: "' + self.loggingConfigfile + '"')
            sys.stderr.write (''.join(e) + "\n")

        self.logger     = self.logging.getLogger('meresco.infra')
        logging.info(startupMessage)
        self.logger.debug(startupMessage)

    def _prettyPrint(self):
        self.pp = pprint.PrettyPrinter(indent=2)

    def prpt(self, label, param):
        return label + "\n" + self.pp.pformat(param)

    def dd(self, label, param):
        self.logging.debug(self.prpt(label, param))

    def getLoggingInstance(self):
        return self.logging


## Test script to prove that it actually works
if __name__ == "__main__":

    # create a first object
    a = Infra("first startup","/home/anton/server/etc/bzv/logging.conf")

    a.foo = 'initial'
    # get and print class variable foo
    print a.foo
    # create a second object

    b =Infra("second startup","/home/anton/server/etc/bzv/logging.conf")

    # set a string to the class variable foo
    b.foo = "Hello Folks"

    # create a third object
    c = Infra("third startup","/home/anton/server/etc/bzv/logging.conf")

    # get and print class variable foo for object a
    print a.foo
    print "configs"

    # get and print class variable foo for object c
    print c.foo

    a.logger.debug("hello world")
