from sys import stdout, stderr
from merescocore.framework import Observable, Transparant
from time import ctime

class Printer(Transparant):
    def __init__(self, name=">>>"):
        Transparant.__init__(self)
        self._name = name

    def unknown(self, message, *args, **kwargs):
        print self._name, message, [str(data)[:20].replace('\n', '\\n') for data in args]
        yield self.all.unknown(message, *args, **kwargs)

class IdentifierPrinter(object):
    def __init__(self, name, outputstream=stdout):
        self._name = name
        self._outputstream = outputstream
    def add(self, identifier, partname, data):
        self._write('add', identifier)
    def delete(self, identifier):
        self._write('delete', identifier)
    def _write(self, action, identifier):
        self._outputstream.write('%s %s %s\n' %(self._name, action, identifier))
        self._outputstream.flush()

class HandleRequestPrinter(object):
    def handleRequest(self, arguments, Client=None, RequestURI=None, **kwargs):
        print ctime(), RequestURI, 'from', Client
        if False:
            yield 'never'

class LimitQuery(Observable):
    def __init__(self, limit):
        Observable.__init__(self)
        self._limit = limit
    def handleRequest(self, arguments, **kwargs):
        query = arguments['query'][0]
        newquery = query + self._limit
        arguments['query'] = [newquery]
        requestArguments = {'arguments': arguments}
        requestArguments.update(kwargs)
        return self.all.handleRequest(**requestArguments)

class SruRecordUpdateDump(object):
    def handleRequest(self, Body='', *args, **kwargs):
        fd = open('srurecordupdates.txt', 'a')
        fd.write(Body.replace('<?xml version="1.0" encoding="UTF-8"?>',''))
        fd.close()
        yield httputils.okXml
        yield """<?xml version="1.0" encoding="UTF-8"?>
<srw:updateRequest xmlns:srw="info:srw/namespace/1/srw-schema" xmlns:ucp="info:srw/namespace/1/update">
    <srw:version>1.0</srw:version>
    <ucp:operationStatus>succes</ucp:operationStatus>
</srw:updateRequest>"""

class MessageLogger(object):
    def __init__(self, stdout=stdout, stderr=stderr):
        self._stdout = stdout
        self._stderr = stderr
        
    def logMessage(self, messageType, message):
        if messageType in ['FAILED', 'ERROR', 'WARNING']:
            self._write(self._stderr, "[%s] %s" % (messageType, message))
        self._write(self._stdout, "[%s] %s" % (messageType, message))
    
    def _write(self, stream, message):
        stream.write(message.rstrip())
        stream.write('\n')
        stream.flush()
