#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# NB er zijn FIXMES in deze file die om aandacht vragen...
#

from __future__ import with_statement

from os import system, makedirs
system('find .. -name "*.pyc" | xargs rm -f')

from glob import glob
import sys
for depspath in glob('../deps.d/*'):
    sys.path.insert(0, depspath)
sys.path.insert(0, '..')

from unittest import TestCase, TestSuite, TextTestRunner
from cq2utils import CallTrace, autostart, getRequest, postRequest, wheelOfTime
from os.path import join, isdir, isfile
from os import remove, rename
from time import sleep, time
from amara.binderytools import bind_file
from merescocore.components.http import ObservableHttpServer
from merescocore.framework import be
from urllib import urlencode
from lxml.etree import tostring

#from pendingfulltext import fulltextRecordsQuery
from bzv.server import main as serverMain
from bzv import Inbox
from weightless import Reactor, compose
from socket import socket
from random import randint
from socket import socket
from errno import EAGAIN as TEMPORARILY_UNAVAILABLE
from subprocess import Popen, PIPE

from shutil import rmtree, copy

### added by tp
from bzv.customerConfig import CustomerConfig
from bzv.infra import Infra
from bzv.configWatcher import ConfigWatcher
###

global port
global reactor
global infra

port = None
reactor = None
integrationTempdir = './integrationtest'
inboxDirectory = join(integrationTempdir, 'inboxDirectory')
doneDirectory = join(integrationTempdir, 'doneDirectory')

def testSuite():
    nonIndexModifyingTests = [
        'testExplain',
# FIXME anton: zolang uitgezet
#        'testHtml',
        'testSruQuery',
        'testMetadataRecordSchemaIsDefault',
        'testDrilldown',
# FIXME anton: zolang uitgezet
#        'testMultiLevelDrilldownInHtml',
        'testNormalizationEmptyDateInXml',
        'testRss',
        'testUndatedRecordsGetUnknown',
# FIXME thomas: uitgezet; DIDL wordt niet meer apart opgeslagen
#        'testDidlIsStored'
    ]

    indexModifyingTests = [
#       'testPendingFulltext',
        'testInbox',
        'testSruQuery',
        'testDrilldown',
        'testReindex',
####### are nonIndexModifingTests not effected?
        'testSruQuery',
        'testDrilldown',
        'testSelectiveReindexing',
####### are nonIndexModifingTests not effected?
        'testSruQuery',
        'testDrilldown',
#        'testRateRecord'
    ]

    missingTests = [k for k in IntegrationTest.__dict__.keys() \
                       if k.startswith('test') and k not in (nonIndexModifyingTests + indexModifyingTests)]
    assert len(missingTests) == 0, missingTests

    return TestSuite([TestSuite([IntegrationTest(test) for test in l]) \
                     for l in [nonIndexModifyingTests, indexModifyingTests]])

class IntegrationTest(TestCase):

    def testExplain(self):
        header, body = getRequest(reactor, port, '/sru', {}, parse=False)
        self.assertTrue('explainResponse' in body, body)
        self.assertTrue('port>%s</' % port in body, body)

### FIXME voorlopig uitgezet
    def NOtestHtml(self):
        header, response = getRequest(reactor, port, '/elsevier', {}, parse=False)
        self.assertTrue('</html>' in response, response)

    def testSruQuery(self):
        message = self._doQuery({'query': 'meta.repository.id exact inboxrepo'})
        dynamiclyInserted = int(str(message.searchRetrieveResponse.numberOfRecords))

        self.assertSruQuery(82 + int(dynamiclyInserted), 'meresco.exists=true')
        self.assertSruQuery(20, 'meta.repository.id exact neeo')
        self.assertSruQuery(61, 'meta.repository.id exact elsevieroai')
        self.assertSruQuery(1,  'meta.repository.id exact pica')
        self.assertSruQuery(20, 'neeo')
        kwargs = {'sru': '/eo/sru'}
        self.assertSruQuery(20, 'neeo', **kwargs)

    def testMetadataRecordSchemaIsDefault(self):
        result = self._doQuery({'query':'test'})
        self.assertEquals('metadata', str(result.searchRetrieveResponse.records.record.recordSchema))
        xmlOutput = result.searchRetrieveResponse.records.record.recordData.xml()
        self.assertTrue('<mods xmlns="http://www.loc.gov/mods/v3"' in xmlOutput, xmlOutput)

    def testDrilldown(self):
        result = self.doDrilldown('elsevier', 'mods.subject.topic')
        navigator = result.extraResponseData.drilldown.term_drilldown.navigator
        self.assertEquals(1, len(navigator))
        self.assertEquals('mods.subject.topic', str(navigator.name))
        self.assertEquals(10, len(navigator.item))

        result = self.doDrilldown('meresco.exists=true', 'meta.repository.id')
        navigator = result.extraResponseData.drilldown.term_drilldown.navigator
        self.assertEquals(1, len(navigator))
        self.assertEquals('meta.repository.id', str(navigator.name))
        print set([str(item) for item in navigator.item])
        resultSet = set([str(item) for item in navigator.item])
        self.assertTrue(set(['elsevieroai', 'neeo', 'pica']).issubset(resultSet), resultSet)

        result = self.doDrilldown('neeo', 'mods.genre')
        navigator = result.extraResponseData.drilldown.term_drilldown.navigator

        self.assertEquals(4, len(navigator.item))
        self.assertEquals(set(['info:eu-repo/semantics/bookPart/', 'info:eu-repo/semantics/conferencePaper/', 'info:eu-repo/semantics/article/', 'info:eu-repo/semantics/doctoralThesis/']), set([str(item) for item in navigator.item]))

### FIXME voorlopig uitgezet
    def NOtestMultiLevelDrilldownInHtml(self):
        html = self.getPage('/nl/page/search?query=')
        self.assertTrue('&drilldown=' in html, html)
        self.assertFalse('&drilldown=drilldown.norm.date.decennium' in html, html[html.index('&drilldown='):])
        self.assertTrue('&drilldown=drilldown.norm.date.year' in html, html[html.index('&drilldown='):])

    def testNormalizationEmptyDateInXml(self):
        result = self._doQuery({'query': 'meta.upload.id exact "elsevieroai:elsevier:CXT0242A:01988859:00690004:08000608"', 'recordSchema': 'extra'})
        extraXml = result.searchRetrieveResponse.records.record.recordData.extra
        self.assertEquals('', str(extraXml.norm.date))

    def testRss(self):
        headers, body = getRequest(reactor, port, '/rss', {'query': 'meta=neeo'}, parse='lxml')
        items = body.xpath('/rss/channel/item')
        self.assertEquals(15, len(items))
        self.assertEquals(['UvT Search Engine (BETA)'], body.xpath('/rss/channel/title/text()'))

    def testUndatedRecordsGetUnknown(self):
        self.assertSruQuery(7, 'mods.originInfo.dateIssued=unknown')

### FIXME voorlopig uitgezet
    def NOtestDidlIsStored(self):
        result = self.assertSruQuery(20, 'meta=neeo', recordSchema='didl')
        xmlData = result.xml()
        self.assertFalse("'didl')' does not exist." in xmlData, xmlData)
        self.assertEquals('urn:nbn:nl:ui:12-402853', str(result.rootNode.searchRetrieveResponse.records.record.recordData.DIDL.Item.Descriptor.Statement.Identifier))

    def doDrilldown(self, query, drilldownField):
        message = self._doQuery({'query':query, 'x-term-drilldown': drilldownField})
        result = message.searchRetrieveResponse
        return result

    # the tests below modify the contents of the index, something the previous tests don't take into account
    # (As the order in which these tests are run is super important, the 'test' decorator is used to add
    # the tests to the test suite one by one).

    def NOtestPendingFulltext(self):
        #self.assertSruQuery(1, fulltextRecordsQuery)
        self.assertSruQuery(0, 'Turing')

        subProcess = Popen(['pendingfulltext.py', 'localhost', str(port), '/sru', 'localhost', str(port), '/update'], stdin=PIPE)
        while subProcess.poll() == None:
            reactor.step()
        if subProcess.poll() != 0:
            print "subProcess.poll() != 0", subProcess.poll()

        serverConfig =  infra.configs['server']
        batch_timeout = int(serverConfig.get('timeout',section='batchTransactions',default="1"))

        wheelOfTime(reactor, batch_timeout + .5)
        #self.assertSruQuery(0, fulltextRecordsQuery)
        self.assertSruQuery(1, 'Turing')

    def testInbox(self):
        message = self._doQuery({'query': 'meta.repository.id exact inboxrepo'})
        oldRecordCount = int(str(message.searchRetrieveResponse.numberOfRecords))
        recordIdentifier = 'inboxrepo:identifier:%s' % (oldRecordCount+1)

        inboxDirectory = join(integrationTempdir, 'inboxDirectory')
        open(integrationTempdir + recordIdentifier, 'w').write("""<mods xmlns="http://www.loc.gov/mods/v3" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="3.3" xsi:schemaLocation="http://www.loc.gov/mods/v3 http://www.loc.gov/standards/mods/v3/mods-3-3.xsd">
        <titleInfo><title>Test record for inbox</title></titleInfo>
        <genre>info:eu-repo/semantics/article</genre>
        <language><languageTerm type="code" authority="iso639-2b">eng</languageTerm></language>
        <originInfo>
            <dateIssued qualifier="inferred">20080525</dateIssued>
        </originInfo>
    </mods>""")

        rename(integrationTempdir + recordIdentifier, join(inboxDirectory, 'col:group:'+recordIdentifier+".record"))
        reactor.step()

        serverConfig =  infra.configs['server']
        batch_timeout = int(serverConfig.get('timeout',section='batchTransactions',default="1"))
        wheelOfTime(reactor, batch_timeout + 0.5)

        message = self._doQuery({'query': 'meta.repository.id exact inboxrepo'})
        newRecordCount = int(str(message.searchRetrieveResponse.numberOfRecords))
        self.assertEquals(oldRecordCount + 1, newRecordCount)

    def testReindex(self):
        if skipReindexTest:
            print "SKIPPING testReindex"
            return
        header, body = self.doReindex('/reindex')
        self.assertEquals('done', body.split('\n')[-1])

    def testSelectiveReindexing(self):
        if skipReindexTest:
            print "SKIPPING testSelectiveReindexing"
            return

        header, body = self.doReindex('/reindex?identifierPrefix=neeo:oai:wo.uvt.nl')
        identifiers = body.split('\n')[:-1]
        self.assertEquals(19, len(identifiers))

        header, body = self.doReindex('/reindex?identifierPrefix=neeo:oai:wo.uvt.nl:402853')
        identifiers = body.split('\n')[:-1]
        self.assertEquals(1, len(identifiers))
        self.assertEquals(['neeo:oai:wo.uvt.nl:402853'], identifiers)

    def NOtestRateRecord(self):
        ratingFile = join(integrationTempdir, 'storage', 'elsevieroai', 'elsevier:CXT0242A:01988859:00690004:08000608', 'rating')
        isfile(ratingFile) and remove(ratingFile)
        recordId = 'elsevieroai:elsevier:CXT0242A:01988859:00690004:08000608'

        result = self._doQuery({'query': 'meta.upload.id exact "%s"' % recordId, 'recordSchema': 'rating'})
        ratingXml = result.searchRetrieveResponse.records.record.recordData.rating
        self.assertEquals('', ratingXml)

        header,body = postRequest(reactor, port, '/rateRecord', urlencode({'recordId': recordId, 'value': 3}), parse=False)
        self.assertTrue('302 ' in header, header+body)

        result = self._doQuery({'query': 'meta.upload.id exact "%s"' % recordId, 'recordSchema': 'rating'})
        ratingXml = result.searchRetrieveResponse.records.record.recordData.rating
        self.assertEquals('3000', str(ratingXml.averageScore))

    def assertSruQuery(self, numberOfRecords, query, **kwargs):
        queryParams = {'query': query}
        queryParams.update(kwargs)
        message = self._doQuery(queryParams)
        self.assertFalse("<diagnostic" in message.xml(), message.xml())
        result = message.searchRetrieveResponse
        self.assertEquals(numberOfRecords, int(str(result.numberOfRecords)))
        return result

    def _resultCount(self, query):
        queryParams = {'query': query}
        queryParams.update(kwargs)
        message = self._doQuery(queryParams)
        return int(str(message.searchRetrieveResponse.numberOfRecords))

    def _doQuery(self, arguments):
        sru = '/sru'
        if 'sru' in arguments:
            sru = arguments['sru']
            del arguments['sru']
        queryArguments = {'version': '1.1', 'operation': 'searchRetrieve', 'recordSchema': 'metadata'}
        queryArguments.update(arguments)
        header, body = getRequest(reactor, port, sru, queryArguments)
        return body

    def getPage(self, url, parse=False):
        header, body = getRequest(reactor, port, url, {}, parse=parse)
        return body

    def doReindex(self, query):
        sok = socket()
        sok.connect(('localhost', port))
        sok.setblocking(0)
        sok.send('GET %s HTTP/1.0\r\n\r\n' % query)

        response = ''

        stopTheLoop = []
        reactor.addTimer(150, lambda: stopTheLoop.append(True))

        while not stopTheLoop:
            try:
                part = sok.recv(1024)
                if not part:
                    break
                response += part
            except Exception, e:
                if e.args[0] != TEMPORARILY_UNAVAILABLE:
                    raise
            reactor.addTimer(0.01, lambda: None)
            reactor.step()
        return response.split('\r\n\r\n')

def createDatabase():
    allOutput = ""
    recordPacking = 'xml'
    start = time()

    src = 'Coffee.pdf'
    dst = integrationTempdir + '/tmp/Coffee.pdf'
    if isfile(dst):
        remove(dst)
    copy(src, dst)

    print "Creating database in", integrationTempdir
    sourceFiles = glob('harvester_output/*.updateRequest')
    for updateRequestFile in sorted(sourceFiles):
        print 'Sending:', updateRequestFile
        header, body = postRequest(reactor, port, '/update', open(updateRequestFile).read())
        if '200 Ok' not in header:
            print 'No 200 Ok response, but:'
            print header
            exit(123)
        if "srw:diagnostics" in body.xml():
            print body.xml()
            exit(1234)

    serverConfig =  infra.configs['server']
    batch_timeout = int(serverConfig.get('timeout',section='batchTransactions',default="1"))

    wheelOfTime(reactor, batch_timeout + 0.5)
    print "Finished creating database in %s seconds" % (time() - start)

if __name__ == '__main__':
    from sys import argv
    skipCreateDatabase = False
    runServer = False
    skipReindexTest = False
    port = 5000
    if '--fast' in argv:
        skipCreateDatabase = True
        argv.remove('--fast')
    if '--runServer' in argv:
        runServer = True
        argv.remove('--runServer')
    else: port = randint(50000,60000)
    if '--noReindex' in argv:
        skipReindexTest = True
        argv.remove('--noReindex')

    if not skipCreateDatabase:
        if isdir(integrationTempdir):
            print "Destroying database"
            rmtree(integrationTempdir)
        makedirs(integrationTempdir)
        makedirs(integrationTempdir + '/tmp')

    baseURL = 'localhost'
    reactor = Reactor()
    observableHttpServer = ObservableHttpServer(reactor, port)
    sruUpdateServer = observableHttpServer

    def ensureDirectory(dirname):
        fullpath = join(integrationTempdir, dirname)
        if not isdir(fullpath):
            makedirs(fullpath)
        return fullpath
    inboxDirectory = ensureDirectory('inboxDirectory')
    doneDirectory = ensureDirectory('doneDirectory')

### added for Infra
    global infra
    infra=Infra('', 'logging.conf')
    configs = {
        'website':    CustomerConfig('../etc/website.cfg',infra),
        'server' :    CustomerConfig('../etc/server.cfg',infra),
        'drilldown':  CustomerConfig('../etc/drilldown.cfg',infra)
        }
    infra.configs = configs
    configWatcher = ConfigWatcher(reactor=reactor, configWatcherDirectory = '../etc', infra = infra, configs=configs )
    inbox = Inbox(reactor=reactor, inboxDirectory=inboxDirectory, doneDirectory=doneDirectory, infra=infra)

    server = be(serverMain(reactor,
        observableHttpServer,
        sruUpdateServer,
        inbox,
        baseURL=baseURL,
        portNumber=port,
        databasePath=integrationTempdir,
        configDict={
            'defaultSortKeys': 'sort.mods.originInfo.dateIssued,,1',
            'applicationName': 'IntegrationTest BZV',
            'inboxDirectory': inboxDirectory,
            'doneDirectory': doneDirectory,
            'dynamicPath': '',
            'staticPath': '',
            'xsltPath': '',
            'picaplusXsltFiles': '',
            'templatePath': '../etc/',

        },
        infra=infra,
        configWatcher=configWatcher
    ))
    #server.printTree()
    server.once.observer_init()
    if skipReindexTest:
        print 'Skipping testReindex!!'
    if skipCreateDatabase and isdir(integrationTempdir):
        print "Reusing database in", integrationTempdir
    else:
        createDatabase()

    if runServer:
        inbox.processInboxDirectory()
        print "Ready to rumble on", baseURL, "at port", port
        print "   - database: integrationtest\n"
        sys.stdout.flush()
        reactor.loop()
    else:
       testRunner = TextTestRunner()
       testRunner.run(testSuite())
